; Copyright  2004 Sebastian Pipping <webmaster@hartwork.org>

!define PRODUCT_NAME              "RAYO Batch"
!define PRODUCT_VERSION           "1.02"
!define PRODUCT_PUBLISHER         "HARTWORK PROJECT"
!define PRODUCT_WEBSITE           "http://www.hartwork.org"
!define PRODUCT_PATH_KEY          "Software\Microsoft\Windows\CurrentVersion\App Paths\rayo.exe"
!define PRODUCT_UNINST_KEY        "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_STARTMENU_VAL     "NSIS:StartMenuDir"
!define PRODUKT_CONTEXT_VAL       "NSIS:ContextType"

SetCompressor lzma


!include "MUI.nsh"

!define MUI_ICON "${NSISDIR}\Source\exehead\nsis.ico"
!define MUI_UNICON "${NSISDIR}\Source\exehead\uninst.ico"



; **********************************************************************************
; **  Directory page
; **********************************************************************************

Function .onVerifyInstDir
  IfFileExists "$INSTDIR\gsdll32.dll" +2
    Abort

FunctionEnd

; Text to display on top of the page.
!define MUI_DIRECTORYPAGE_TEXT_TOP "Setup needs to know where [gsdll32.dll] of AFPL Ghostscript is installed.$\nPlease select the folder containing [gsdll32.dll]. Click Next to continue."

; Text to display on the destination folder frame.
!define MUI_DIRECTORYPAGE_TEXT_DESTINATION "Folder containg [gsdll32.dll]"

!insertmacro MUI_PAGE_DIRECTORY



; **********************************************************************************
; **  Start menu page
; **********************************************************************************

var ICONS_GROUP
!define MUI_STARTMENUPAGE_NODISABLE
!define MUI_STARTMENUPAGE_DEFAULTFOLDER "${PRODUCT_NAME}"
!define MUI_STARTMENUPAGE_REGISTRY_ROOT HKLM
!define MUI_STARTMENUPAGE_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME ${PRODUCT_STARTMENU_VAL}
!insertmacro MUI_PAGE_STARTMENU Application $ICONS_GROUP



; **********************************************************************************
; **  Instfiles page
; **********************************************************************************

!insertmacro MUI_PAGE_INSTFILES


; **********************************************************************************
; **  UNINST Instfile page
; **********************************************************************************

!insertmacro MUI_UNPAGE_INSTFILES


; Language files
!insertmacro MUI_LANGUAGE "English"

; Reserve files
!insertmacro MUI_RESERVEFILE_INSTALLOPTIONS



; **********************************************************************************
; **  General
; **********************************************************************************

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "..\Release\rayo_batch_102_setup.exe"

InstallDir "$PROGRAMFILES\gs\gs8.14\bin"

InstallDirRegKey HKLM "${PRODUCT_PATH_KEY}" ""
ShowInstDetails show
ShowUnInstDetails show



; **********************************************************************************
; **  INSTALL
; **********************************************************************************

!define PS_HOME_CREATE 0
!define PS_HOME_EXPAND 1
!define PS_AWAY_EXPAND 2

Var VAR_CONTEXT_DEST

Section -INSTALL
  SetOutPath "$INSTDIR"
  SetOverwrite ifnewer

  File "..\Release\rayo.exe"
  File "rayo_readme.txt"
  WriteUninstaller "$INSTDIR\rayo_uninst.exe"

  CreateDirectory "$SMPROGRAMS\$ICONS_GROUP"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Readme.lnk" "$INSTDIR\rayo_readme.txt"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Uninstall.lnk" "$INSTDIR\rayo_uninst.exe"

  WriteRegStr HKLM "${PRODUCT_PATH_KEY}" "" "$INSTDIR\rayo.exe"
  WriteRegStr HKLM "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr HKLM "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\rayo_uninst.exe"
  WriteRegStr HKLM "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\rayo.exe"
  WriteRegStr HKLM "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr HKLM "${PRODUCT_UNINST_KEY}" "${PRODUCT_STARTMENU_VAL}" "$ICONS_GROUP"
  WriteRegStr HKLM "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEBSITE}"
  WriteRegStr HKLM "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"


  ClearErrors
  ReadRegStr $VAR_CONTEXT_DEST HKCR ".ps" ""

  IfErrors 0 Found
    WriteRegStr HKCR ".ps" "" "rayo_batch"
    WriteRegStr HKCR ".ps" "Content Type" "application/postscript"

    WriteRegStr HKCR "rayo_batch" "" "PostScript File"
    WriteRegStr HKCR "rayo_batch\shell\rayo" "" "Convert to PDF"
    WriteRegStr HKCR "rayo_batch\shell\rayo\command" "" '$INSTDIR\rayo.exe "%L"'
    
    WriteRegDWORD HKLM "${PRODUCT_UNINST_KEY}" "${PRODUKT_CONTEXT_VAL}" ${PS_HOME_CREATE}
    Goto Done

  Found:
    StrCmp $VAR_CONTEXT_DEST "" Home Away

    Home:
      WriteRegStr HKCR ".ps\shell\rayo" "" "Convert to PDF"
      WriteRegStr HKCR ".ps\shell\rayo\command" "" '$INSTDIR\rayo.exe "%L"'
      WriteRegDWORD HKLM "${PRODUCT_UNINST_KEY}" "${PRODUKT_CONTEXT_VAL}" ${PS_HOME_EXPAND}
      Goto Done

    Away:
      WriteRegStr HKCR "$VAR_CONTEXT_DEST\shell\rayo" "" "Convert to PDF"
      WriteRegStr HKCR "$VAR_CONTEXT_DEST\shell\rayo\command" "" '$INSTDIR\rayo.exe "%L"'
      WriteRegDWORD HKLM "${PRODUCT_UNINST_KEY}" "${PRODUKT_CONTEXT_VAL}" ${PS_AWAY_EXPAND}

  Done:

SectionEnd



; **********************************************************************************
; **  UNINST
; **********************************************************************************

VAR VAR_CONTEXT_TYPE

Section Uninstall
  ReadRegStr $ICONS_GROUP HKLM "${PRODUCT_UNINST_KEY}" "${PRODUCT_STARTMENU_VAL}"
  ReadRegDWORD $VAR_CONTEXT_TYPE HKLM "${PRODUCT_UNINST_KEY}" "${PRODUKT_CONTEXT_VAL}"

  IntCmp $VAR_CONTEXT_TYPE ${PS_AWAY_EXPAND} 0 CMP_HOME_EXPAND CMP_HOME_CREATE
    ClearErrors
    ReadRegStr $VAR_CONTEXT_DEST HKCR ".ps" ""
    IfErrors CMP_DONE 0
      DeleteRegKey HKCR "$VAR_CONTEXT_DEST\shell\rayo"
      Goto CMP_DONE
    
  CMP_HOME_EXPAND:
    IntCmp $VAR_CONTEXT_TYPE ${PS_AWAY_EXPAND} CMP_HOME_CREATE
    DeleteRegKey HKCR ".ps\shell\rayo"
    Goto CMP_DONE

  CMP_HOME_CREATE:
    DeleteRegKey HKCR ".ps"
    DeleteRegKey HKCR "rayo_batch"

  CMP_DONE:

  Delete "$INSTDIR\rayo.exe"
  Delete "$INSTDIR\rayo_readme.txt"
  Delete "$INSTDIR\rayo_uninst.exe"

  Delete "$SMPROGRAMS\$ICONS_GROUP\Readme.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\Uninstall.lnk"

  RMDir "$SMPROGRAMS\$ICONS_GROUP"

  DeleteRegKey HKLM "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_PATH_KEY}"
  SetAutoClose true

SectionEnd



; **********************************************************************************
; **  UNINST Callbacks
; **********************************************************************************

Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) was successfully removed from your computer."

FunctionEnd


Function un.onInit
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Are you sure you want to completely remove $(^Name) and all of its components?" IDYES +2
    Abort

FunctionEnd

